#!/usr/bin/perl

use strict;

print "# Dependency list automatically generated by gendepend.pl\n\n";

&concatenate_lines();

sub process_line {
    my $line = shift;
    my $max = 78;
    my $first = 1;
    
    $line =~ s|/usr/include/\S+||g;  # remove SDL etc header files
    $line =~ s/  +/ /g;              # remove duplicate spaces
    
    while($line =~ /(.{1,$max})(\s|$)/g) {
        if($first) {
            $first = 0;
            $max -= 4;
        }
        else {
            print " \\\n    ";
        }
        
        print "$1";
    }
    
    print "\n\n";
}

sub concatenate_lines {
    my $line = '';
    
    while(<>) {
        chomp;                       # remove newline
        
        if(!/:/) {
            $line =~ s/\\$//;        # remove trailing backslash
            $line .= ' ' . $_;
        }
        else {
            if($line ne '') {        # if it's not the first line
                &process_line($line);
            }
            
            $line = $_;
        }
    }
    
    if($line ne '') {
        &process_line($line);
    }
}
